#
# Copyright (c) 1996-2004, Yauheni Akhotnikau
# Copyright (c) 2004, JSC Intervale
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
#	this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#	this list of conditions and the following disclaimer in the documentation
#	and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products derived
#	from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

require 'mxx_ru/ex'

#     ,    
# ,  - ,
#   .
module Mxx_ru

	class	Binary_target < Mxx_ru::Abstract_target
		def initialize( a_prj_alias )
			super( a_prj_alias )

			#  ,     ,  
			#     .
			@mxx_required_libs = Array.new
			#  ,    mxx_required_libs
			#   .
			@mxx_required_libs_changed = true
			#  ,     , 
			#  mxx_required_libs.
			@mxx_required_lib_paths = Array.new
			#  ,    mxx_required_lib_paths
			#   .
			@mxx_required_lib_paths_changed = true
		end

		#    ,   
		#      .
		#   .
		def mxx_required_libs
			if @mxx_required_libs_changed
				@mxx_required_libs.flatten!
				@mxx_required_libs_changed = false
			end
			return @mxx_required_libs
		end

		#       .
		def mxx_add_required_lib( a_lib )
			@mxx_required_libs << a_lib
			@mxx_required_libs_changed = true
		end

		#      ,  
		#    ,  
		# mxx_required_libs.
		#   .
		def mxx_required_lib_paths
			if @mxx_required_lib_paths_changed
				@mxx_required_lib_paths.flatten!
				@mxx_required_lib_paths_changed = false
			end
			return @mxx_required_lib_paths
		end

		#      ,  
		#    .
		def mxx_add_required_lib_path( a_path )
			@mxx_required_lib_paths << a_path
			@mxx_required_lib_paths_changed = true
		end

	end

end
