#
# Copyright (c) 1996-2004, Yauheni Akhotnikau
# Copyright (c) 2004, JSC Intervale
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
#	this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#	this list of conditions and the following disclaimer in the documentation
#	and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products derived
#	from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

require	'mxx_ru/ex'
require	'mxx_ru/abstract_target'

module Mxx_ru

#  ,   unit-test   .
#
#    ,    ,  
#   unit-test.     
# -,   Mxx_ru::Binary_target.
#   unit-test-     , 
#   -  Mxx_ru::Binary_unittest_target.
# :
#
#    unit-test-.
#	Mxx_ru::setup_target(
#		Mxx_ru::Cpp::Exe_target.new( "test/pack/prj.rb" ) {
#			...
#		}
#	)
#
#    unit-test-.
#	Mxx_ru::setup_target(
#		Mxx_ru::Binary_unittest_target.new( 
#			"test/pack/ut.rb",
#			"test/pack/prj.rb ) )
#
# ,   unit-test.
#	Mxx_ru::setup_target(
#		Mxx_ru::Cpp::Composite_target( Mxx_ru::BUILD_ROOT ) {
#			required_prj( "some/project/prj.rb" )
#			required_prj( "test/pack/ut.rb" )
#		}
# )
#
class	Binary_unittest_target < Abstract_target

	# ,  ,  
	#      .
	class	Must_be_one_target_name_ex < Ex
		# _a_names_
		#   .
		def initialize( a_names )
			super( "Only one name expected in [#{a_names.join(';')}]" )
		end
	end

	# ,     unit-test .
	attr_reader	:mxx_target_project
	#  ,   build  .
	attr_reader	:mxx_build_state

	# .
	#
	# _a_alias_
	#  .
	#
	# _a_target_project_
	# ,     unit-test .
	def	initialize( a_alias, a_target_project )
		super( a_alias )

		@mxx_build_state = nil

		@mxx_target_project = required_prj( a_target_project )
	end

	#      .
	#
	#   unit-test    0 ,
	#   .
	def	build
		if !@mxx_build_state
			@mxx_target_project.build

			#   ,   .
			full_names = @mxx_target_project.mxx_full_targets_names
			if 1 != full_names.size
				raise Must_be_one_target_name_ex.new( full_names )
			end

			#   dry-run    .
			if !Mxx_ru::Util::Mode.instance.is_dry_run
				puts "running unit test: #{full_names[0]}..."
				if !system( full_names[ 0 ] )
					puts "\n\nunit test '#{full_names[0]}' FAILED! #{$?}"
					raise Build_ex.new( full_names[ 0 ], $? )
				end
			end

			@mxx_build_state = Target_state.new( Target_state::REBUILT )
		end

		return @mxx_build_state
	end

	#  .
	#
	#    clean   .
	def	clean
		@mxx_target_project.clean
	end
end

end
