#
# Copyright (c) 1996-2004, Yauheni Akhotnikau
# Copyright (c) 2004, JSC Intervale
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
#	this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#	this list of conditions and the following disclaimer in the documentation
#	and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products derived
#	from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

require 'mxx_ru/cpp/target'

module	Mxx_ru

	module Cpp

		#      .
		class	Composite_target_type < Target_type
			TYPE = "composite"

			def name
				return TYPE
			end
		end

		# ,     .
		class	Composite_target < Target
			def	initialize( a_alias, &block )
				super( a_alias )

				instance_eval( &block ) if block
			end

			def target_type
				return Composite_target_type.new
			end

			def	build
				if nil == @mxx_last_build_result

					if !@mxx_all_options_defined
						# ,  toolset   
						#     .
						Mxx_ru::Cpp::toolset.setup_mandatory_options( self )
						@mxx_all_options_defined = true
					end

					@mxx_last_build_result = build_required_projects
				end

				return @mxx_last_build_result

			end

			def clean
				if nil == @mxx_last_build_result

					if !@mxx_all_options_defined
						# ,  toolset   
						#     .
						Mxx_ru::Cpp::toolset.setup_mandatory_options( self )
						@mxx_all_options_defined = true
					end

					clean_required_prjs

					@mxx_last_build_result = Mxx_ru::Target_state.new(
						Mxx_ru::Target_state::ABSENT )
				end
			end

		end # class Composite_target

	end # module Cpp

end # module Mxx_ru
