#
# Copyright (c) 1996-2004, Yauheni Akhotnikau
# Copyright (c) 2004, JSC Intervale
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
#	this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#	this list of conditions and the following disclaimer in the documentation
#	and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products derived
#	from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

require	'singleton'

module	Mxx_ru
module	Cpp

	#     Ruby,   Mxx_ru::Cpp.
	MXXCPPARG_RELEASE = "--mxx-cpp-release"
	MXXCPPARG_DEBUG = "--mxx-cpp-debug"
	MXXCPPARG_ONLY_ONE = "--mxx-cpp-1"
	MXXCPPARG_NO_DEPENDS_ANALYZER = "--mxx-cpp-no-depends-analyzer"

	# ,  ,     Mxx_ru::Cpp.
	class	Mode
		include Singleton

		attr_reader	:is_release
		attr_reader	:is_debug
		attr_reader	:is_only_one
		attr_reader	:is_no_depends_analyzer

		#     
		#   .
		def	initialize
			@is_release = ARGV.include?( MXXCPPARG_RELEASE )
			@is_debug = ARGV.include?( MXXCPPARG_DEBUG )
			@is_only_one = ARGV.include?( MXXCPPARG_ONLY_ONE )
			@is_no_depends_analyzer = ARGV.include?( MXXCPPARG_NO_DEPENDS_ANALYZER )
			@manual_dry_run_counter = 0
		end

		#    / .
		#    is_only_one  
		# manual_dry_run_counter  0,    
		# dry_run.
		def	before_subprj_processing
			if is_only_one
				if 0 == @manual_dry_run_counter
					Mxx_ru::Util::Mode.instance.manual_dry_run( true )
				end
				@manual_dry_run_counter += 1
			end
		end

		#    / .
		#    is_only_one  
		# manual_dry_run_counter  0,    
		# dry_run.
		def	after_subprj_processing
			if is_only_one
				@manual_dry_run_counter -= 1
				if 0 == @manual_dry_run_counter
					Mxx_ru::Util::Mode.instance.manual_dry_run( false )
				end
			end
		end

	end

end # module Cpp
end # module Mxx_ru
