#
# Copyright (c) 1996-2004, Yauheni Akhotnikau
# Copyright (c) 2004-2005, JSC Intervale
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
#	this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#	this list of conditions and the following disclaimer in the documentation
#	and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products derived
#	from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

require 'mxx_ru/abstract_target.rb'

module Mxx_ru
module Cpp

# ,     C++  
#   {RuCodeGen}[http://eao197.narod.ru/rucodegen]
#
#     C++    ,
#       sources_root   
#   .
#
# ,     
# my_prj/pub.rb  my_prj/impl/details.rb:
#
#	require 'mxx_ru/cpp'
#	require 'mxx_ru/cpp/rucodegen'
#
#	Mxx_ru::setup_target( Mxx_ru::Cpp::Exe_target.new( "my_prj/prj.rb" ) {
#		...
#		rucodegen = generator( Mxx_ru::Cpp::RuCodeGen.new( self ) )
#		...
#		rucodegen << "pub.rb"
#		...
#		sources_root( "impl" ) {
#			rucodegen << "details.rb"
#			...
#		}
#		...
#	})
#
# <b></b>.      
#      RuCodeGen#add
#
#	rucodegen.add "details.rb"
#
class	RuCodeGen < Abstract_generator
	# ,     .
	attr_reader :target

	#    .
	attr_reader	:scripts


	# .
	#
	# _target_ -- ,     .
	def	initialize( target )
		@target = target
		@scripts = []
	end

	#     .
	def <<( script )
		@scripts << @target.create_full_src_file_name( script )
	end

	alias_method :add, :<<

	#  .
	def	build( target )
		@scripts.each do |s|
			Abstract_target.run( make_build_cmd( s, :build ), [] )
		end
	end

	#    .
	def	clean( target )
		@scripts.each do |s|
			Abstract_target.run( make_build_cmd( s, :clean ), [] )
		end
	end

protected
	#       .
	#
	# _script_name_   .
	# _mode_    <tt>--mode</tt> (:build  :clean).
	def make_build_cmd( script_name, mode )
		"ruby #{script_name} --mode #{mode}"
	end
end

end # module Cpp
end # module Mxx_ru

