#
# Copyright (c) 1996-2004, Yauheni Akhotnikau
# Copyright (c) 2004, JSC Intervale
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
#	this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#	this list of conditions and the following disclaimer in the documentation
#	and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products derived
#	from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

module Mxx_ru
	module Cpp

		#      C/C++ .
		class	Cpp_source_file
			#   ().
			attr	:name
			#   ,    .
			attr	:compiler_options
			#  ,     .
			attr	:depends

			def initialize( file_name, a_compiler_options )
				@name = file_name
				if a_compiler_options
					@compiler_options = a_compiler_options.clone
				else
					@compiler_options = Array.new
				end
				@depends = Array.new
			end
		end # module Cpp_source_file

		#     mswin- .
		class	Mswin_rc_file
			#   ().
			attr	:name
			#  ,     .
			attr	:depends

			def initialize( file_name, a_depends = nil )
				@name = file_name

				if a_depends
					@depends = a_depends.clone
				else
					@depends = Array.new
				end
			end
		end # module Mswin_rc_file

	end # module Cpp
end # module Mxx_ru
